import static com.sun.btrace.BTraceUtils.println;
import static com.sun.btrace.BTraceUtils.str;
import static com.sun.btrace.BTraceUtils.Threads.currentThread;
import static com.sun.btrace.BTraceUtils.Threads.name;
import static com.sun.btrace.BTraceUtils.Strings.newStringBuilder;
import static com.sun.btrace.BTraceUtils.Strings.compareTo;
import static com.sun.btrace.BTraceUtils.Strings.append;

import com.sun.btrace.annotations.BTrace;
import com.sun.btrace.annotations.Duration;
import com.sun.btrace.annotations.Kind;
import com.sun.btrace.annotations.Location;
import com.sun.btrace.annotations.OnMethod;
import com.sun.btrace.annotations.ProbeClassName;
import com.sun.btrace.annotations.ProbeMethodName;
import com.sun.btrace.annotations.TLS;


@BTrace
public class TomcatCallStackBTrace {
	static {
		println("# Web CallStackTrace Started !!!");
		println("# us == micro second == 1/1,000,000 second ");
	}

	@TLS private static Appendable tabsPre=null;
	@TLS private static Appendable tabsPost=null;
	@TLS private static String threadName="";
	@TLS private static int indent=0;
	
	public static void makeTabPre() {
		threadName=name(currentThread());
		if(compareTo(threadName,"ContainerBackgroundProcessor[StandardEngine[Catalina]]")!=0) { 
			tabsPre=newStringBuilder(true);
			append(tabsPre,str(indent));
			append(tabsPre," [");
			append(tabsPre,threadName);
			append(tabsPre,"]-");
			if(indent==1) {
				append(tabsPre," *** ");
			}
		}
	}
	public static void makeTabPost() {
		threadName=name(currentThread());
//		println(threadName);
		if(compareTo(threadName,"ContainerBackgroundProcessor[StandardEngine[Catalina]]")!=0) { 
			tabsPost=newStringBuilder(true);
			append(tabsPost,str(indent));
			append(tabsPost," [");
			append(tabsPost,threadName);
			append(tabsPost,"]-");
			if(indent==1) {
				append(tabsPost," *** ");
			}
		}
	}	
	@OnMethod(
			clazz="/org.apache.catalina.*/",
			method = "/.*/"
	)
	public static void onMethodEntry(@ProbeClassName String pcn,
			@ProbeMethodName String pmn) {
		indent++;
		makeTabPre();
		if(tabsPre!=null) {
			append(tabsPre,pcn);
			append(tabsPre,".");
			append(tabsPre,pmn);
			append(tabsPre," =====> called ");
			println(tabsPre);
		}
	}
	
	@OnMethod(
			clazz="/org.apache.catalina.*/",
			method = "/.*/", 
			location = @Location(Kind.RETURN)
	)
	public static void onMethodReturn(@ProbeClassName String pcn,
			@ProbeMethodName String pmn, @Duration long d) {
		makeTabPost();
		if(tabsPost!=null) {
			append(tabsPost,pcn);
			append(tabsPost,".");
			append(tabsPost,pmn);
			append(tabsPost,"[");
			append(tabsPost,str(d / 1000));
			append(tabsPost,"] us");
			println(tabsPost);
		}
		indent--;
		if(indent<0) {
			indent=0;
		}
	}
	
}

